Use Windows.pkg
Use DFClient.pkg

Use cMyLibXLWithFormats.pkg
Use cTextEdit.pkg
Use cCJGrid.pkg
Use cCJGridColumnRowIndicator.pkg
Use cCJGridColumn.pkg
Use ShellExecute.Pkg

Deferred_View Activate_oTabelleSchreibenSheetsBilder for ;
Object oTabelleSchreibenSheetsBilder is a dbView
    Set Border_Style to Border_Thick
    Set Size to 231 300
    Set Location to 2 2
    Set Label to "7. Tabelle Schreiben Sheets & Bilder"
    
    Property String[][] psArrayValues
    
    Object oLibXL is a cMyLibXLWithFormats
    End_Object            

    Object oButtonTabelleSchreibenSheetsHinzufuegen is a Button
        Set Size to 14 146
        Set Location to 12 9
        Set Label to "XLSX Schreiben (3 Sheets)"
        
        Object oLibXL is a cMyLibXLWithFormats
        End_Object
        
        Procedure OnClick
            String sFileName
            Handle hoBook hoSheet0 hoSheet1 hoSheet2
            Boolean bFileExists
            
            // Datei erstellen
            Get CreateXMLBook of oLibXL to hoBook
            // Formate initialisieren
            Send InitalizeMyLibXLBook of oLibXL hoBook

            // Sheet erstellen
            Get AddSheet of hoBook "Demo 1" to hoSheet0
            Get AddSheet of hoBook "Demo 2" to hoSheet1
            Get AddSheet of hoBook "Demo 3" to hoSheet2
            
            Move ( (psDirectory(Self)) + "DemoSchreibenSheetBilder.xlsx" ) to sFileName
            
            // Alte Xlsx lschen
            File_Exist sFileName bFileExists
            If (bFileExists) Begin
                EraseFile sFileName
            End
            

            Send SaveAs of hoBook sFileName
            Send destroy to hoBook
            Send Info_Box ("Die Datei" * sFileName * "wurde erstellt")
        End_Procedure
    End_Object

    Object oButtonTabelleSchreibenSheetFinden is a Button
        Set Size to 14 146
        Set Location to 29 9
        Set Label to "Suche nach Handle fr Sheet 'Demo 2'"
        
        Object oLibXL is a cMyLibXLWithFormats
        End_Object
        
        Procedure OnClick
            String sFileName sValue
            Handle hoBook hoSheet hoSheets
            Integer iCol iCols iRow iRows
            
            Move ( (psDirectory(Self)) + "DemoSchreibenSheetBilder.xlsx" ) to sFileName
            
            Get Load of oLibXL sFileName to hoBook
            If (hoBook = 0) Begin
                Send Stop_Box ("Die Datei\n\n" + sFileName + "\n\nkonnte nicht gefunden werden") 
                Procedure_Return
            End
            
            // psName Name des Sheets
            Get SheetByName of hoBook "Demo 2" to hoSheet
            
            Send Info_Box ("Handle von 'Demo 2':" * (String(hoSheet)) )
            Send Destroy of hoBook
        End_Procedure
    End_Object

    Object oButtonTabelleAnzahlBilderInSheet3 is a Button
        Set Size to 14 146
        Set Location to 76 9
        Set Label to "Anzahl der Bilder"
        
        Object oLibXL is a cMyLibXLWithFormats
        End_Object
        
        Procedure OnClick
            String sFileName sPictureName
            Handle hoBook hoSheet hoSheets
            Integer iNumPics
            xlPictureId iPictureID
            
            Move ( (psDirectory(Self)) + "DemoSchreibenSheetBilder.xlsx" ) to sFileName
            
            Get Load of oLibXL sFileName to hoBook
            If (hoBook = 0) Begin
                Send Stop_Box ("Die Datei\n\n" + sFileName + "\n\nkonnte nicht gefunden werden") 
                Procedure_Return
            End
            
            // psName Name des Sheets
            Get SheetByName of hoBook "Demo 3" to hoSheet
            Get PictureCount of hoSheet to iNumPics
            Send Info_Box iNumPics
            Send Destroy to hoBook
        End_Procedure
    End_Object

    Object oButtonTabelleBildEinfuegenOriginal is a Button
        Set Size to 14 146
        Set Location to 93 9
        Set Label to "Bild in Originalgre einfgen"
        
        Object oLibXL is a cMyLibXLWithFormats
        End_Object
        
        Procedure OnClick
            String sFileName sPictureName
            Handle hoBook hoSheet hoSheets
            Integer iNumPics
            xlPictureId iPictureID
            
            Move ( (psDirectory(Self)) + "DemoSchreibenSheetBilder.xlsx" ) to sFileName
            Move ( (psDirectory(Self)) + "DataAccess.jpg" ) to sPictureName
            
            Get Load of oLibXL sFileName to hoBook
            If (hoBook = 0) Begin
                Send Stop_Box ("Die Datei\n\n" + sFileName + "\n\nkonnte nicht gefunden werden") 
                Procedure_Return
            End
            
            // psName Name des Sheets
            Get SheetByName of hoBook "Demo 3" to hoSheet
            
            Get AddPictureFromFile of hoSheet sPictureName to iPictureID
            Send SetPicture of hoSheet iPictureID 2 5 0 0
            Send Info_Box ("Die Datei" * sFileName * "wurde gespeichert")
            
            Send SaveAs of hoBook sFileName
            Send Destroy to hoBook
        End_Procedure
    End_Object

    Object oButtonTabelleBildEinfuegenRate is a Button
        Set Size to 14 146
        Set Location to 109 9
        Set Label to "Bild in 2,5 facher Gre einfgen"
        
        Object oLibXL is a cMyLibXLWithFormats
        End_Object
        
        Procedure OnClick
            String sFileName sPictureName
            Handle hoBook hoSheet hoSheets
            Integer iNumPics
            xlPictureId iPictureID
            
            Move ( (psDirectory(Self)) + "DemoSchreibenSheetBilder.xlsx" ) to sFileName
            Move ( (psDirectory(Self)) + "DataAccess.jpg" ) to sPictureName
            
            Get Load of oLibXL sFileName to hoBook
            If (hoBook = 0) Begin
                Send Stop_Box ("Die Datei\n\n" + sFileName + "\n\nkonnte nicht gefunden werden") 
                Procedure_Return
            End
            
            // psName Name des Sheets
            Get SheetByName of hoBook "Demo 3" to hoSheet
            
            Get AddPictureFromFile of hoSheet sPictureName to iPictureID
            Send SetPictureScaled of hoSheet iPictureID 5 5 0 0 2.5
            Send Info_Box ("Die Datei" * sFileName * "wurde gespeichert")
            
            Send SaveAs of hoBook sFileName
            Send Destroy to hoBook
        End_Procedure
    End_Object

    Object oButtonXLSOeffnen is a Button
        Set Location to 13 235
        Set Label to "XLSX ffnen"
    
        Procedure OnClick
            Handle hWnd hInstance
            String sFileName

            Move ( (psDirectory(Self)) + "DemoSchreibenSheetBilder.xlsx" ) to sFileName
            Move (ShellExecute (hWnd, "open", sFileName, '', '', 0)) to hInstance
        End_Procedure
    End_Object

    Object oTextBox1 is a TextBox
        Set Auto_Size_State to False
        Set Size to 10 106
        Set Location to 62 10
        Set Label to "Weitere Aktionen in Sheet 3!"
        Set FontWeight to fw_Bold
    End_Object
Cd_End_Object
